/*
 * SymbolToStringComposer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnciek
 */

#ifndef SYMBOL_TO_STRING_COMPOSER_H_
#define SYMBOL_TO_STRING_COMPOSER_H_

#include <ostream>
#include "Symbol.h"

namespace alphabet {

/**
 * This class contains methods to print XML representation of string to the output stream.
 */
class SymbolToStringComposer : public VisitableSymbolBase::const_visitor_type {
	void Visit(void*, const LabeledSymbol& symbol) const;
	void Visit(void*, const BlankSymbol& symbol) const;
	void Visit(void*, const BottomOfTheStackSymbol& symbol) const;
	void Visit(void*, const EndSymbol& symbol) const;
	void Visit(void*, const StartSymbol& symbol) const;
	void Visit(void*, const RankedSymbol& symbol) const;
	void Visit(void*, const BarSymbol& symbol) const;
	void Visit(void*, const RankedBarSymbol& symbol) const;
	void Visit(void*, const SubtreeWildcardSymbol& symbol) const;
	void Visit(void*, const SymbolPairSymbol& symbol) const;
	void Visit(void*, const SymbolSetSymbol& symbol) const;
	void Visit(void*, const UniqueSymbol& symbol) const;

public:
	/**
	 * Prints text representation of Symbol to the output stream.
	 * @param string String to print
	 * @param out output stream to which print the String
	 */
	void compose(std::ostream& output, const Symbol& string) const;
};

} /* namespace alphabet */

#endif /* SYMBOL_TO_STRING_COMPOSER_H_ */
