/*
 * FiniteAutomatonFromStringLexer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef FINITE_AUTOMATON_FROM_STRING_LEXER_H_
#define FINITE_AUTOMATON_FROM_STRING_LEXER_H_

#include <string>
#include <sstream>

namespace automaton {

class FiniteAutomatonFromStringLexer {
public:
	enum class TokenType {
		EPSILON_NFA,
		MULTI_INITIAL_STATE_NFA,
		NFA,
		DFA,
		OUT,
		IN,
		EPSILON,
		SEPARATOR,
		NONE,
		NEW_LINE,
		TEOF,
		ERROR
	};

	struct Token {
		TokenType type;
		std::string value;
		std::string raw;
	};

	Token next(std::istream& input) const;
	void putback(std::istream&, Token token) const;
};

} /* namepsace automaton */

#endif /* FINITE_AUTOMATON_FROM_STRING_LEXER_H_ */
