/*
 * ExceptionToXMLComposer.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "ExceptionToXMLComposer.h"

#include "../XmlApi.hpp"

namespace exception {

void ExceptionToXMLComposer::compose(std::list<sax::Token>& out, const AlibException& exception) const {
	out.push_back(sax::Token(alib::Names::EXCEPTION_ALIB_EXCEPTION, sax::Token::TokenType::START_ELEMENT));
	out.push_back(sax::Token("cause", sax::Token::TokenType::START_ELEMENT));
	out.push_back(sax::Token(exception.getCause(), sax::Token::TokenType::CHARACTER));
	out.push_back(sax::Token("cause", sax::Token::TokenType::END_ELEMENT));
	out.push_back(sax::Token("backtrace", sax::Token::TokenType::START_ELEMENT));
	out.push_back(sax::Token(exception.getBacktrace(), sax::Token::TokenType::CHARACTER));
	out.push_back(sax::Token("backtrace", sax::Token::TokenType::END_ELEMENT));
	out.push_back(sax::Token(alib::Names::EXCEPTION_ALIB_EXCEPTION, sax::Token::TokenType::END_ELEMENT));
}

} /* namespace exception */
