/*
 * GrammarFromStringParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef GRAMMAR_FROM_STRING_PARSER_H_
#define GRAMMAR_FROM_STRING_PARSER_H_

#include "GrammarFromStringLexer.h"
#include "Grammar.h"
#include "GrammarFeatures.h"
#include "../alphabet/Symbol.h"
#include <set>
#include <vector>

namespace alib {

template<typename T>
struct stringApi;

} /* namespace alib */

namespace grammar {

class GrammarFromStringParser {
	GrammarFromStringLexer m_GrammarLexer;

	std::set<alphabet::Symbol> parseSet(std::istream& input) const;
	std::map<alphabet::Symbol, std::set<std::vector<alphabet::Symbol>>> parseCFLikeRules(std::istream& input) const;

	Grammar parseGrammar(std::istream& input) const;
	Grammar parseGrammar(std::istream& input, const std::set<FEATURES>& features) const;

	RightRG parseRightRG(std::istream& input) const;
	CNF parseCNF(std::istream& input) const;

	template<typename T> friend class alib::stringApi;
};

} /* namespace grammar */

#endif /* GRAMMAR_FROM_STRING_PARSER_H_ */
