#ifndef GRAMMAR_TO_STRING_COMPOSER_H_
#define GRAMMAR_TO_STRING_COMPOSER_H_

#include <iostream>
#include "Grammar.h"

#include <map>
#include <list>
#include <set>

namespace grammar {

class GrammarToStringComposer : public VisitableGrammarBase::const_visitor_type {
	void Visit(void*, const LeftLG& grammar) const;
	void Visit(void*, const LeftRG& grammar) const;
	void Visit(void*, const RightLG& grammar) const;
	void Visit(void*, const RightRG& grammar) const;
	void Visit(void*, const LG& grammar) const;
	void Visit(void*, const CFG& grammar) const;
	void Visit(void*, const EpsilonFreeCFG& grammar) const;
	void Visit(void*, const CNF& grammar) const;
	void Visit(void*, const GNF& grammar) const;
	void Visit(void*, const CSG& grammar) const;
	void Visit(void*, const NonContractingGrammar& grammar) const;
	void Visit(void*, const ContextPreservingUnrestrictedGrammar& grammar) const;
	void Visit(void*, const UnrestrictedGrammar& grammar) const;

public:
	/**
	 * Prints XML representation of Automaton to the output stream.
	 * @param automaton automaton to print
	 * @return list of xml tokens representing the automaton
	 */
	void compose(std::ostream& output, const Grammar& grammar) const;

	void compose(std::ostream& output, const LeftLG& grammar) const;
	void compose(std::ostream& output, const LeftRG& grammar) const;
	void compose(std::ostream& output, const RightLG& grammar) const;
	void compose(std::ostream& output, const RightRG& grammar) const;
	void compose(std::ostream& output, const LG& grammar) const;
	void compose(std::ostream& output, const CFG& grammar) const;
	void compose(std::ostream& output, const EpsilonFreeCFG& grammar) const;
	void compose(std::ostream& output, const CNF& grammar) const;
	void compose(std::ostream& output, const GNF& grammar) const;
	void compose(std::ostream& output, const CSG& grammar) const;
	void compose(std::ostream& output, const NonContractingGrammar& grammar) const;
	void compose(std::ostream& output, const ContextPreservingUnrestrictedGrammar& grammar) const;
	void compose(std::ostream& output, const UnrestrictedGrammar& grammar) const;
};

}

#endif /* GRAMMAR_TO_STRING_COMPOSER_H_ */
