/*
 * LabelFromStringLexer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef LABEL_FROM_STRING_LEXER_H_
#define LABEL_FROM_STRING_LEXER_H_

#include <string>
#include <sstream>

namespace label {

class LabelFromStringLexer {
public:
	enum class TokenType {
		SET_BEGIN,
		SET_END,
		PAIR_BEGIN,
		PAIR_END,
		COMMA,
		TEOF,
		ERROR
	};

	struct Token {
		TokenType type;
		std::string value;
		std::string raw;
	};

	Token next(std::istream& input) const;
	void putback(std::istream& input, Token token) const;
};

} /* namespace label */

#endif /* LABEL_FROM_STRING_LEXER_H_ */
