/*
 * Object.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Martin Zak
 */

#ifndef OBJECT_H_
#define OBJECT_H_

#include "../common/wrapper.hpp"
#include "../std/compare.hpp"

namespace alib {

class ObjectBase;

/**
 * Wrapper around object.
 */
typedef alib::wrapper<ObjectBase> Object;

} /* namespace alib */

#include "ObjectBase.h"

namespace std {

template<>
struct compare<alib::Object> {
	int operator()(const alib::Object& first, const alib::Object& second) const {
		return first.getData().compare(second.getData());
	}
};

} /* namespace std */

#endif /* OBJECT_H_ */

