/*
 * PrimitiveFromStringParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef PRIMITIVE_FROM_STRING_PARSER_H_
#define PRIMITIVE_FROM_STRING_PARSER_H_

#include "Primitive.h"
#include "PrimitiveFeatures.h"
#include <set>

#include "PrimitiveFromStringLexer.h"

namespace alib {

template<typename T>
struct stringApi;

} /* namespace alib */

namespace primitive {

class PrimitiveFromStringParser {
	PrimitiveFromStringLexer m_Lexer;

	Primitive parsePrimitive(std::istream&, const std::set<FEATURES>&) const;
	Primitive parsePrimitive(std::istream&) const;

	template<typename T> friend class alib::stringApi;
};

} /* namespace primitive */

#endif /* PRIMITIVE_FROM_STRING_PARSER_H_ */
