/*
 * Unsigned.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#include "Unsigned.h"

namespace primitive {

Unsigned::Unsigned(unsigned data) : data(data) {

}

PrimitiveBase* Unsigned::clone() const {
	return new Unsigned(*this);
}

PrimitiveBase* Unsigned::plunder() && {
	return new Unsigned(std::move(*this));
}

unsigned Unsigned::getData() const {
	return data;
}

int Unsigned::compare(const Unsigned& other) const {
	return data - other.data;
}

void Unsigned::operator>>(std::ostream& out) const {
	out << "(Unsigned " << data << ")";
}

Unsigned::operator std::string() const {
	return std::to_string(data);
}

} /* namespace primitive */

