/*
 * FormalRegExpEpsilon.cpp
 *
 *  Created on: Jan 30, 2014
 *      Author: Jan Travnicek
 */

#include "FormalRegExpEpsilon.h"
#include "../unbounded/UnboundedRegExpEpsilon.h"
#include <sstream>

namespace regexp {

FormalRegExpEpsilon::FormalRegExpEpsilon() {
  // so that default constructor is available
}

FormalRegExpEpsilon::FormalRegExpEpsilon(const FormalRegExpEpsilon&) {
  // so that copy constructor is available
}

FormalRegExpEpsilon::FormalRegExpEpsilon(FormalRegExpEpsilon&&) noexcept {
	this->attachRegExp(NULL);
}

FormalRegExpEpsilon& FormalRegExpEpsilon::operator =(const FormalRegExpEpsilon&) {
  //this is actually different than default implementation
  return *this;
}

FormalRegExpEpsilon& FormalRegExpEpsilon::operator =(FormalRegExpEpsilon&&) noexcept {
  //this is actually different than default implementation
  return *this;
}

FormalRegExpElement* FormalRegExpEpsilon::clone() const {
	return new FormalRegExpEpsilon(*this);
}

FormalRegExpElement* FormalRegExpEpsilon::plunder() && {
	return new FormalRegExpEpsilon(std::move(*this));
}

UnboundedRegExpElement* FormalRegExpEpsilon::cloneAsUnbounded() const {
	return new UnboundedRegExpEpsilon();
}

int FormalRegExpEpsilon::compare(const FormalRegExpEpsilon&) const {
	  return 0;
}

void FormalRegExpEpsilon::operator>>(std::ostream& out) const {
	out << "(FormalRegExpEpsilon)";
}

bool FormalRegExpEpsilon::testSymbol( const alphabet::Symbol & ) const {
	return false;
}

bool FormalRegExpEpsilon::attachRegExp(const FormalRegExp * regexp ) {
	if(this->parentRegExp == regexp) return true;
	this->parentRegExp = regexp;
	return true;
}

void FormalRegExpEpsilon::computeMinimalAlphabet( std::set<alphabet::Symbol>&) const {

}

FormalRegExpEpsilon::operator std::string() const {
	std::stringstream ss;
	ss << *this;
	return ss.str();
}

} /* namespace regexp */
