/*
 * StringToXMLComposer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnciek
 */

#ifndef STRING_TO_XML_COMPOSER_H_
#define STRING_TO_XML_COMPOSER_H_

#include <list>
#include "String.h"
#include "../sax/Token.h"
#include "../alphabet/Symbol.h"

namespace alib {

template<typename T>
struct xmlApi;

} /* namespace alib */

namespace string {

/**
 * This class contains methods to print XML representation of string to the output stream.
 */
class StringToXMLComposer {
	/**
	 * Prints XML representation of String to the output stream.
	 * @param string String to print
	 * @param out output stream to which print the String
	 */
	void compose(std::list<sax::Token>& out, const StringBase& string) const;

	/**
	 * Prints XML representation of String to the output stream.
	 * @param string String to print
	 * @param out output stream to which print the String
	 */
	void compose(std::list<sax::Token>& out, const String& string) const;

	void compose(std::list<sax::Token>& out, const LinearString& string) const;
	void compose(std::list<sax::Token>& out, const CyclicString& string) const;
	void compose(std::list<sax::Token>& out, const Epsilon& string) const;

	template<typename T> friend class alib::xmlApi;
};

} /* namespace string */

#endif /* STRING_TO_XML_COMPOSER_H_ */
